/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.records.TCoreMaintenanceRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreMaintenance extends TableImpl<TCoreMaintenanceRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_maintenance</code>
     */
    public static final TCoreMaintenance T_CORE_MAINTENANCE = new TCoreMaintenance();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreMaintenanceRecord> getRecordType() {
        return TCoreMaintenanceRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_maintenance.lastchange</code>.
     */
    public final TableField<TCoreMaintenanceRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_maintenance.pk</code>. unique id
     */
    public final TableField<TCoreMaintenanceRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "unique id");

    /**
     * The column <code>common_dd.t_core_maintenance.message</code>. message to
     * be displayed on web applications
     */
    public final TableField<TCoreMaintenanceRecord, String> MESSAGE = createField(DSL.name("message"), SQLDataType.CLOB.nullable(false), this, "message to be displayed on web applications");

    /**
     * The column <code>common_dd.t_core_maintenance.downtime_start</code>.
     * estimated downtime start
     */
    public final TableField<TCoreMaintenanceRecord, LocalDateTime> DOWNTIME_START = createField(DSL.name("downtime_start"), SQLDataType.LOCALDATETIME(6).nullable(false), this, "estimated downtime start");

    /**
     * The column <code>common_dd.t_core_maintenance.downtime_end</code>.
     * estimated downtime end
     */
    public final TableField<TCoreMaintenanceRecord, LocalDateTime> DOWNTIME_END = createField(DSL.name("downtime_end"), SQLDataType.LOCALDATETIME(6).nullable(false), this, "estimated downtime end");

    /**
     * The column <code>common_dd.t_core_maintenance.affected_shippie</code>. is
     * Shippie affected?
     */
    public final TableField<TCoreMaintenanceRecord, Boolean> AFFECTED_SHIPPIE = createField(DSL.name("affected_shippie"), SQLDataType.BOOLEAN.nullable(false), this, "is Shippie affected?");

    /**
     * The column
     * <code>common_dd.t_core_maintenance.affected_shipdesigner</code>. is
     * Shipdesigner affected?
     */
    public final TableField<TCoreMaintenanceRecord, Boolean> AFFECTED_SHIPDESIGNER = createField(DSL.name("affected_shipdesigner"), SQLDataType.BOOLEAN.nullable(false), this, "is Shipdesigner affected?");

    /**
     * The column <code>common_dd.t_core_maintenance.affected_square</code>. is
     * Square affected?
     */
    public final TableField<TCoreMaintenanceRecord, Boolean> AFFECTED_SQUARE = createField(DSL.name("affected_square"), SQLDataType.BOOLEAN.nullable(false), this, "is Square affected?");

    /**
     * The column <code>common_dd.t_core_maintenance.affected_sam</code>. is Sam
     * affected?
     */
    public final TableField<TCoreMaintenanceRecord, Boolean> AFFECTED_SAM = createField(DSL.name("affected_sam"), SQLDataType.BOOLEAN.nullable(false), this, "is Sam affected?");

    private TCoreMaintenance(Name alias, Table<TCoreMaintenanceRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreMaintenance(Name alias, Table<TCoreMaintenanceRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_maintenance</code> table
     * reference
     */
    public TCoreMaintenance(String alias) {
        this(DSL.name(alias), T_CORE_MAINTENANCE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_maintenance</code> table
     * reference
     */
    public TCoreMaintenance(Name alias) {
        this(alias, T_CORE_MAINTENANCE);
    }

    /**
     * Create a <code>common_dd.t_core_maintenance</code> table reference
     */
    public TCoreMaintenance() {
        this(DSL.name("t_core_maintenance"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreMaintenanceRecord, Integer> getIdentity() {
        return (Identity<TCoreMaintenanceRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreMaintenanceRecord> getPrimaryKey() {
        return Keys.PK_CORE_MAINTENANCE;
    }

    @Override
    public TCoreMaintenance as(String alias) {
        return new TCoreMaintenance(DSL.name(alias), this);
    }

    @Override
    public TCoreMaintenance as(Name alias) {
        return new TCoreMaintenance(alias, this);
    }

    @Override
    public TCoreMaintenance as(Table<?> alias) {
        return new TCoreMaintenance(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreMaintenance rename(String name) {
        return new TCoreMaintenance(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreMaintenance rename(Name name) {
        return new TCoreMaintenance(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreMaintenance rename(Table<?> name) {
        return new TCoreMaintenance(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMaintenance where(Condition condition) {
        return new TCoreMaintenance(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMaintenance where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMaintenance where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMaintenance where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMaintenance where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMaintenance where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMaintenance where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMaintenance where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMaintenance whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMaintenance whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
